package com.fp.persistence.parmas.param;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMUNIDADTIPO*/
@Entity(name="TarmUnidadTipo")
@Table(name="TARMUNIDADTIPO")
public class TarmUnidadTipo extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmUnidadTipo
*/
@EmbeddedId
private TarmUnidadTipoKey pk;
@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Versión del Registro
*/
private Integer recordversion;

@Column(name="FECHAREGISTRO", nullable=true)

/**
* Fecha de Registro
*/
private Date fecharegistro;

/**Contructor por defecto*/
public TarmUnidadTipo(){
}
/**Contructor de TarmUnidadTipo
@param pPk Clave Primaria del entity
*/
public TarmUnidadTipo(TarmUnidadTipoKey pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmUnidadTipo
*/
public static TarmUnidadTipo find(EntityManager pEntityManager,TarmUnidadTipoKey pKey) throws Exception{
    TarmUnidadTipo obj = pEntityManager.find(TarmUnidadTipo.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmUnidadTipo
@return El objeto que referencia a la Clave primaria de TarmUnidadTipo
*/
public TarmUnidadTipoKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmUnidadTipo
@param pPk El objeto que referencia a la nueva Clave primaria de TarmUnidadTipo
*/
public void setPk(TarmUnidadTipoKey pPk){
  pk=pPk;
}
/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de fecharegistro
@return valor de fecharegistro*/
public Date getFecharegistro(){
  return fecharegistro;
}
/**Fija el valor de fecharegistro
@param pFecharegistro nuevo Valor de fecharegistro*/
public void setFecharegistro(Date pFecharegistro){
  fecharegistro=pFecharegistro;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmUnidadTipo))return false;
    TarmUnidadTipo that = (TarmUnidadTipo) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmUnidadTipo
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmUnidadTipo
*/
public Object createInstance(){
 TarmUnidadTipo instance=new TarmUnidadTipo();	
 instance.setPk(new TarmUnidadTipoKey());
 return instance;
}
/**Clona la entidad TarmUnidadTipo
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmUnidadTipo p=(TarmUnidadTipo)this.clone();
  p.setPk((TarmUnidadTipoKey)this.pk.cloneMe());
  return p;
}
}
